package ru.dbotthepony.mc.otm.menu.matter

import net.minecraft.world.SimpleContainer
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.core.immutableList
import ru.dbotthepony.mc.otm.block.entity.matter.PatternStorageBlockEntity
import ru.dbotthepony.mc.otm.core.math.Decimal
import ru.dbotthepony.mc.otm.menu.MatteryMenu
import ru.dbotthepony.mc.otm.menu.PatternSlot
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget
import ru.dbotthepony.mc.otm.registry.MMenus

class PatternStorageMenu @JvmOverloads constructor(
	p_38852_: Int,
	inventory: Inventory,
	tile: PatternStorageBlockEntity? = null
) : MatteryMenu(
	MMenus.PATTERN_STORAGE, p_38852_, inventory, tile
) {
	val storedThis: LevelGaugeWidget
	val storedGrid: LevelGaugeWidget

	val storageSlots: List<PatternSlot>

	init {
		if (tile == null) {
			storedThis = LevelGaugeWidget(this)
			storedGrid = LevelGaugeWidget(this)
		} else {
			storedThis = LevelGaugeWidget(this, tile)
			storedGrid = LevelGaugeWidget(this, {
				Decimal(tile.matterGraph?.patternCount ?: 0)
			}, {
				Decimal(tile.matterGraph?.patternCapacity ?: 0)
			})
		}

		val patterns = tile?.container ?: SimpleContainer(2 * 4)

		storageSlots = immutableList(2 * 4) {
			addStorageSlot(PatternSlot(patterns, it))
		}

		addInventorySlots()
	}
}
